/* --------------------------------------------------------- */
/*	osziFOX ʐMW[									 */
/* ========================================================= */
/*	(C)2004 t.hara											 */
/* --------------------------------------------------------- */

#pragma once

class CFoxConnect {
public:
	enum {
		DATA_SIZE		= 138,
		WAVE_OFFSET		= 4,
		WAVE_SIZE		= 128,

		DEFAULT_PORT	= 0,	/* default COM port number 0=COM1, 1=COM2 ... */
	};

private:
	int PortNumber;
	HANDLE hPort;
	HANDLE hThread;
	HANDLE hDoReceive;
	HANDLE hReceiveNotify;
	CRITICAL_SECTION HandleSaveCs;
	volatile BOOL fThreadDrive;
	BYTE Data[ DATA_SIZE ];

	void Receive( void );
	static unsigned int CALLBACK ReceiveThread( void *pParameter );
	BOOL WaitSyncSignal( void );

public:
	CFoxConnect();
	~CFoxConnect();
	void Initialize( void );
	void Terminate( void );
	BOOL SetPortNumber( int _PortNumber );
	int GetPortNumber( void );
	void GetData( BYTE *pData );
	HANDLE GetSyncObject( void ) const {
		return hReceiveNotify;
	}
	void Start( void );
	void Stop( void );
	BOOL IsStart( void );
};

class CFoxData {
public:
	BYTE Data[ CFoxConnect::DATA_SIZE ];

	CFoxData();
	void SetData( CFoxConnect *pConnect );
	void SetData( BYTE *pData );

	int GetVoltage( void );
	int GetTimeBase( void );
	LPCTSTR GetCoupling( void );
	LPCTSTR GetTriggerType( void );
	float GetTriggerLevel( void );
};
