// osziFoxViewerView.h : interface of the COsziFoxViewerView class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

class COsziFoxViewerView : public CWindowImpl<COsziFoxViewerView>
{
private:
	Brush *pBackBrush;
	Pen *pGraphPen;
	Pen *pGraphGridPen;
	Pen *pGraphGridDotPen;
	Brush *pTextBrush;
	Font *pTextFont;
	Bitmap *pBackScreen;

	CFoxConnect *pConnect;
	CFoxData Wave;

	void Update( void );
	static unsigned int CALLBACK UpdateCheck( void *pThis );
	HANDLE hUpdateThread;
	volatile BOOL fDrive;
	HANDLE hReceiveEvent;

	CRITICAL_SECTION BackScreenCs;
public:

	COsziFoxViewerView();
	~COsziFoxViewerView();

	DECLARE_WND_CLASS(NULL)

	BOOL PreTranslateMessage(MSG* pMsg);
	void SetUpdateNotifyEvent( HANDLE hEvent ) {
		hReceiveEvent = hEvent;
	}
	void SetConnection( CFoxConnect *p ) {
		pConnect = p;
	}
	void DrawGraph( void );

	BEGIN_MSG_MAP(COsziFoxViewerView)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
	END_MSG_MAP()

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/);
	LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
};
